<?php
if (!defined("ROOT_PATH"))
{
	header("HTTP/1.1 403 Forbidden");
	exit;
}
class pjAdminSurveys extends pjAdmin
{
	public function pjActionCreate()
	{
		$this->checkLogin();
		
		if ($this->isAdmin())
		{
			if (isset($_POST['survey_create']))
			{
				$pjSurveyModel = pjSurveyModel::factory();
				$data = array();
				$id = $pjSurveyModel->setAttributes(array_merge($_POST, $data))->insert()->getInsertId();
				if ($id !== false && (int) $id > 0)
				{
					pjSurveyFormFieldModel::factory()->initSurveyForm($id, $this->getLocaleId());
					$err = 'ASV03';
					if (isset($_POST['i18n']))
					{
						pjMultiLangModel::factory()->saveMultiLang($_POST['i18n'], $id, 'pjSurvey', 'data');
					}
					
					$data_question = array();
					$data_question['survey_id'] = $id;
					$data_question['status'] = 'F';
					$data_question['parent_id'] = 0;
					$data_question['lft'] = 1;
					$data_question['rgt'] = 2;
					pjSurveyQuestionModel::factory()->setAttributes($data_question)->insert();	
					
					if(isset($_POST['user_id']))
					{
						$pjSurveyAvailableUserModel = pjSurveyAvailableUserModel::factory();
						$pjSurveyAvailableUserModel->begin();
						foreach ($_POST['user_id'] as $user_id){
							$data = array();
							$data['survey_id'] = $id;
							$data['user_id'] = $user_id;
							$pjSurveyAvailableUserModel->reset()->setAttributes($data)->insert();
						}
						$pjSurveyAvailableUserModel->commit();
					}
					pjUtil::redirect($_SERVER['PHP_SELF'] . "?controller=pjAdminSurveyQuestions&action=pjActionIndex&survey_id=".$id."&err=ASV03");
				} else {
					pjUtil::redirect($_SERVER['PHP_SELF'] . "?controller=pjAdminSurveys&action=pjActionIndex&err=ASV04");
				}
			} else {
				$locale_arr = pjLocaleModel::factory()->select('t1.*, t2.file')
					->join('pjLocaleLanguage', 't2.iso=t1.language_iso', 'left')
					->where('t2.file IS NOT NULL')
					->orderBy('t1.sort ASC')->findAll()->getData();
						
				$lp_arr = array();
				foreach ($locale_arr as $item)
				{
					$lp_arr[$item['id']."_"] = $item['file'];
				}
				
				$this->set('lp_arr', $locale_arr);
				$this->set('locale_str', pjAppController::jsonEncode($lp_arr));
				$this->set('user_arr', pjUserModel::factory()->where('t1.role_id', 2)->orderBy('t1.name ASC')->findAll()->getData());
						
				$this->appendJs('jquery.tipsy.js', PJ_THIRD_PARTY_PATH . 'tipsy/');
				$this->appendCss('jquery.tipsy.css', PJ_THIRD_PARTY_PATH . 'tipsy/');
				$this->appendJs('jquery.multiselect.min.js', PJ_THIRD_PARTY_PATH . 'multiselect/');
				$this->appendCss('jquery.multiselect.css', PJ_THIRD_PARTY_PATH . 'multiselect/');
				$this->appendJs('jquery.validate.min.js', PJ_THIRD_PARTY_PATH . 'validate/');
				$this->appendJs('jquery.multilang.js', PJ_FRAMEWORK_LIBS_PATH . 'pj/js/');
				$this->appendJs('pjAdminSurveys.js');
			}
		} else {
			$this->set('status', 2);
		}
	}
		
	public function pjActionDeleteSurvey()
	{
		$this->setAjax(true);
	
		if ($this->isXHR())
		{
			$response = array();
			if (pjSurveyModel::factory()->setAttributes(array('id' => $_GET['id']))->erase()->getAffectedRows() == 1)
			{
				pjMultiLangModel::factory()->where('model', 'pjSurvey')->where('foreign_id', $_GET['id'])->eraseAll();
				pjSurveyFormFieldModel::factory()->where('foreign_id', $_GET['id'])->eraseAll();
				pjSurveyAvailableUserModel::factory()->where('survey_id', $_GET['id'])->eraseAll();
				$response['code'] = 200;
			} else {
				$response['code'] = 100;
			}
			pjAppController::jsonResponse($response);
		}
		exit;
	}
	
	public function pjActionDeleteSurveyBulk()
	{
		$this->setAjax(true);
	
		if ($this->isXHR())
		{
			if (isset($_POST['record']) && count($_POST['record']) > 0)
			{
				pjMultiLangModel::factory()->where('model', 'pjSurvey')->whereIn('foreign_id', $_POST['record'])->eraseAll();
				pjSurveyModel::factory()->whereIn('id', $_POST['record'])->eraseAll();
				pjSurveyFormFieldModel::factory()->whereIn('foreign_id', $_POST['record'])->eraseAll();
				pjSurveyAvailableUserModel::factory()->whereIn('survey_id', $_POST['record'])->eraseAll();
			}
		}
		exit;
	}
	
	public function pjActionGetSurvey()
	{
		$this->setAjax(true);
	
		if ($this->isXHR())
		{
			$pjSurveyModel = pjSurveyModel::factory()
				->join('pjMultiLang', "t2.foreign_id = t1.id AND t2.model = 'pjSurvey' AND t2.locale = '".$this->getLocaleId()."' AND t2.field = 'title'", 'left');
			
			if (isset($_GET['q']) && !empty($_GET['q']))
			{
				$q = pjObject::escapeString($_GET['q']);
				$pjSurveyModel->where('t2.content LIKE', "%$q%");
			}
			if (isset($_GET['status']) && !empty($_GET['status']) && in_array($_GET['status'], array('T', 'F')))
			{
				$pjSurveyModel->where('t1.status', $_GET['status']);
			}

			$column = 'id';
			$direction = 'ASC';
			if (isset($_GET['direction']) && isset($_GET['column']) && in_array(strtoupper($_GET['direction']), array('ASC', 'DESC')))
			{
				$column = $_GET['column'];
				$direction = strtoupper($_GET['direction']);
			}

			$total = $pjSurveyModel->findCount()->getData();
			$rowCount = isset($_GET['rowCount']) && (int) $_GET['rowCount'] > 0 ? (int) $_GET['rowCount'] : 20;
			$pages = ceil($total / $rowCount);
			$page = isset($_GET['page']) && (int) $_GET['page'] > 0 ? intval($_GET['page']) : 1;
			$offset = ((int) $page - 1) * $rowCount;
			if ($page > $pages)
			{
				$page = $pages;
			}
			
			$data = $pjSurveyModel
				->select('t1.*, t2.content AS `title`,
				(SELECT COUNT(*) FROM `'.pjSurveyQuestionModel::factory()->getTable().'` WHERE `survey_id` = t1.id AND `status` = "T" AND `parent_id` > 0) AS `num_questions`,
				(SELECT COUNT(*) FROM `'.pjSurveyUserModel::factory()->getTable().'` WHERE `survey_id` = t1.id AND `status`="completed") AS `num_completed`,
				(SELECT COUNT(*) FROM `'.pjSurveyUserModel::factory()->getTable().'` WHERE `survey_id` = t1.id AND `status`="started") AS `num_started`')
				->orderBy("`$column` $direction")
				->limit($rowCount, $offset)
				->findAll()
				->getData();
			
			pjAppController::jsonResponse(compact('data', 'total', 'pages', 'page', 'rowCount', 'column', 'direction'));
		}
		exit;
	}
		
	public function pjActionIndex()
	{
		$this->checkLogin();
		
		if ($this->isAdmin())
		{
			$this->appendJs('jquery.datagrid.js', PJ_FRAMEWORK_LIBS_PATH . 'pj/js/');
			$this->appendJs('pjAdminSurveys.js');
		} else {
			$this->set('status', 2);
		}
	}
	
	public function pjActionSaveSurvey()
	{
		$this->setAjax(true);
	
		if ($this->isXHR())
		{
			$pjSurveyModel = pjSurveyModel::factory();
			if (!in_array($_POST['column'], $pjSurveyModel->getI18n()))
			{
				$pjSurveyModel->where('id', $_GET['id'])->limit(1)->modifyAll(array($_POST['column'] => $_POST['value']));
			} else {
				pjMultiLangModel::factory()->updateMultiLang(array($this->getLocaleId() => array($_POST['column'] => $_POST['value'])), $_GET['id'], 'pjSurvey', 'data');
			}
		}
		exit;
	}
	
	public function pjActionUpdate()
	{
		$this->checkLogin();

		if ($this->isAdmin())
		{
			$pjSurveyFormFieldModel = pjSurveyFormFieldModel::factory();
			if (isset($_POST['survey_update']))
			{
				$data = array();
				pjSurveyModel::factory()->where('id', $_POST['id'])->limit(1)->modifyAll(array_merge($_POST, $data));
				if (isset($_POST['i18n']))
				{
					pjMultiLangModel::factory()->updateMultiLang($_POST['i18n'], $_POST['id'], 'pjSurvey', 'data');
				}
				
				$pjSurveyAvailableUserModel = pjSurveyAvailableUserModel::factory();
				$pjSurveyAvailableUserModel->where('survey_id', $_POST['id'])->eraseAll();
				if(isset($_POST['user_id']))
				{
					$pjSurveyAvailableUserModel->reset()->begin();
					foreach ($_POST['user_id'] as $user_id){
						$data = array();
						$data['survey_id'] = $_POST['id'];
						$data['user_id'] = $user_id;
						$pjSurveyAvailableUserModel->reset()->setAttributes($data)->insert();
					}
					$pjSurveyAvailableUserModel->commit();
				}
				
				pjUtil::redirect(PJ_INSTALL_URL . "index.php?controller=pjAdminSurveys&action=pjActionUpdate&id=".(int)$_POST['id']."&err=ASV01");
				
			} else if (isset($_POST['options_update'])) {
				foreach ($_POST as $key => $value)
				{
					if (preg_match('/value-(string|text|int|float|enum|bool|color)-(.*)/', $key) === 1)
					{
						list(, $type, $k) = explode("-", $key);
						if (!empty($k))
						{
							$pjSurveyFormFieldModel
								->reset()
								->where('foreign_id', $_POST['id'])
								->where('`key`', $k)
								->limit(1)
								->modifyAll(array('value' => $value));
						}
					}
				}
				pjUtil::redirect($_SERVER['PHP_SELF'] . "?controller=pjAdminSurveys&action=pjActionUpdate&id=".(int)$_POST['id']."&tab_id=".@$_POST['tab_id']."&err=AO02");
			} else if (isset($_POST['email_update'])) {
				foreach ($_POST as $key => $value)
				{
					if (preg_match('/value-(string|text|int|float|enum|bool|color)-(.*)/', $key) === 1)
					{
						list(, $type, $k) = explode("-", $key);
						if (!empty($k))
						{
							$pjSurveyFormFieldModel
								->reset()
								->where('foreign_id', $_POST['id'])
								->where('`key`', $k)
								->limit(1)
								->modifyAll(array('value' => $value));
						}
					}
				}
				if (isset($_POST['i18n']))
				{
					pjMultiLangModel::factory()->updateMultiLang($_POST['i18n'], $_POST['id'], 'pjSurveyForm', 'data');
				}
				pjUtil::redirect($_SERVER['PHP_SELF'] . "?controller=pjAdminSurveys&action=pjActionUpdate&id=".(int)$_POST['id']."&tab_id=".@$_POST['tab_id']."&err=AO02");
			} else {
				$arr = pjSurveyModel::factory()->select('t1.*, t2.content AS `title`')
						->join('pjMultiLang', "t2.foreign_id = t1.id AND t2.model = 'pjSurvey' AND t2.locale = '".$this->getLocaleId()."' AND t2.field = 'title'", 'left')
						->find($_GET['id'])->getData();
				if (count($arr) === 0)
				{
					pjUtil::redirect(PJ_INSTALL_URL. "index.php?controller=pjAdminSurveys&action=pjActionIndex&err=ASV08");
				}
				$arr['i18n'] = pjMultiLangModel::factory()->getMultiLang($arr['id'], 'pjSurvey');
				$this->set('arr', $arr);
				
				$survey_form_field_arr = $pjSurveyFormFieldModel->reset()
					->where('t1.foreign_id', $_GET['id'])
					->orderBy('t1.order ASC')
					->findAll()
					->getData();
				
				$this->set('survey_form_field_arr', $survey_form_field_arr);
				
				$data_field_arr = $pjSurveyFormFieldModel->reset()->getPairs($_GET['id']);
				$data_field_arr['i18n'] = pjMultiLangModel::factory()->getMultiLang($_GET['id'], 'pjSurveyForm');
				$this->set('data_field_arr', $data_field_arr);
				
				$locale_arr = pjLocaleModel::factory()->select('t1.*, t2.file, t2.title')
					->join('pjLocaleLanguage', 't2.iso=t1.language_iso', 'left')
					->where('t2.file IS NOT NULL')
					->orderBy('t1.sort ASC')->findAll()->getData();
				
				$lp_arr = array();
				foreach ($locale_arr as $item)
				{
					$lp_arr[$item['id']."_"] = $item['file']; 
				}
				
				$this->set('locale_arr', $locale_arr);
				$this->set('lp_arr', $locale_arr);
				$this->set('locale_str', pjAppController::jsonEncode($lp_arr));
				$this->set('user_arr', pjUserModel::factory()->where('t1.role_id', 2)->orderBy('t1.name ASC')->findAll()->getData());
				$this->set('user_ids_arr', pjSurveyAvailableUserModel::factory()->where('t1.survey_id', $arr['id'])->findAll()->getDataPair(null, 'user_id'));
				
				$this->appendCss('codemirror.css', PJ_THIRD_PARTY_PATH . 'codemirror/');
				$this->appendJs('codemirror.js', PJ_THIRD_PARTY_PATH . 'codemirror/');
			
				$this->appendJs('jquery.multiselect.min.js', PJ_THIRD_PARTY_PATH . 'multiselect/');
				$this->appendCss('jquery.multiselect.css', PJ_THIRD_PARTY_PATH . 'multiselect/');
			
				$this->appendJs('jquery.validate.min.js', PJ_THIRD_PARTY_PATH . 'validate/');
				$this->appendJs('jquery.multilang.js', PJ_FRAMEWORK_LIBS_PATH . 'pj/js/');
				$this->appendJs('jquery.tipsy.js', PJ_THIRD_PARTY_PATH . 'tipsy/');
				$this->appendCss('jquery.tipsy.css', PJ_THIRD_PARTY_PATH . 'tipsy/');
				$this->appendJs('pjAdminSurveys.js');
			}
		} else {
			$this->set('status', 2);
		}
	}
	
	public function pjActionCompleted()
	{
		$this->checkLogin();
		
		if ($this->isAdmin())
		{
			$this->appendJs('jquery.datagrid.js', PJ_FRAMEWORK_LIBS_PATH . 'pj/js/');
			$this->appendJs('pjAdminSurveys.js');
		} else {
			$this->set('status', 2);
		}
	}
	
	public function pjActionGetCompletedSurvey()
	{
		$this->setAjax(true);
	
		if ($this->isXHR())
		{
			$pjSurveyUserModel = pjSurveyUserModel::factory()
				->join('pjMultiLang', "t2.foreign_id = t1.survey_id AND t2.model = 'pjSurvey' AND t2.locale = '".$this->getLocaleId()."' AND t2.field = 'title'", 'left')
				->join('pjUser', 't3.id=t1.user_id', 'left outer');
			
			if (isset($_GET['q']) && !empty($_GET['q']))
			{
				$q = pjObject::escapeString($_GET['q']);
				$pjSurveyUserModel->where('(t2.content LIKE "%'.$q.'%" OR t3.name LIKE "%'.$q.'%")');
			}
			if (isset($_GET['survey_id']) && (int)$_GET['survey_id'] > 0) {
				$pjSurveyUserModel->where('t1.survey_id', (int)$_GET['survey_id']);
			}
			
			if (isset($_GET['status']) && in_array($_GET['status'], array('started', 'completed'))) {
				$pjSurveyUserModel->where('t1.status', $_GET['status']);
			}
			
			$column = 'created';
			$direction = 'DESC';
			if (isset($_GET['direction']) && isset($_GET['column']) && in_array(strtoupper($_GET['direction']), array('ASC', 'DESC')))
			{
				$column = $_GET['column'];
				$direction = strtoupper($_GET['direction']);
			}

			if (isset($_GET['column']) && in_array($_GET['column'], array('date_completion', 'time_completion'))) {
				$column = 'dt_end_survey';
			}
			$total = $pjSurveyUserModel->findCount()->getData();
			$rowCount = isset($_GET['rowCount']) && (int) $_GET['rowCount'] > 0 ? (int) $_GET['rowCount'] : 20;
			$pages = ceil($total / $rowCount);
			$page = isset($_GET['page']) && (int) $_GET['page'] > 0 ? intval($_GET['page']) : 1;
			$offset = ((int) $page - 1) * $rowCount;
			if ($page > $pages)
			{
				$page = $pages;
			}
			
			$data = $pjSurveyUserModel
				->select('t1.*, t2.content AS `survey_title`, t3.name AS `user_name`')
				->orderBy("`$column` $direction")
				->limit($rowCount, $offset)
				->findAll()
				->getData();
			foreach ($data as $k => $item) {
				if (!empty($item['dt_end_survey'])) {
					$seconds = strtotime($item['dt_end_survey']) - strtotime($item['dt_start_survey']);
					$obj_time = pjUtil::secondsToTime($seconds);
					$time_completion = array();
					if($obj_time['h'] > 0)
					{
						$time_completion[] = $obj_time['h'] . ' ' . ($obj_time['h'] == 1 ? __('lblHour', true) : __('lblHours', true));
					}
					if($obj_time['m'] > 0)
					{
						$time_completion[] = $obj_time['m'] . ' ' . ($obj_time['m'] == 1 ? __('lblMinute', true) : __('lblMinutes', true));
					}
					if($obj_time['s'] > 0)
					{
						$time_completion[] = $obj_time['s'] . ' ' . ($obj_time['s'] == 1 ? __('lblSecond', true) : __('lblSeconds', true));
					}
					$data[$k]['date_completion'] = date($this->option_arr['o_date_format'], strtotime($item['dt_end_survey'])) . ', ' . date($this->option_arr['o_time_format'], strtotime($item['dt_end_survey']));
					$data[$k]['time_completion'] = implode(" ", $time_completion);
				} else {
					$data[$k]['date_completion'] = '';
					$data[$k]['time_completion'] = '';
				}
				if ((int)$item['user_id'] == 0) {
					$data[$k]['user_name'] = __('lblAnonymous', true);
				}
			}
			pjAppController::jsonResponse(compact('data', 'total', 'pages', 'page', 'rowCount', 'column', 'direction'));
		}
		exit;
	}
	
	public function pjActionDeleteCompletedSurvey()
	{
		$this->setAjax(true);
	
		if ($this->isXHR())
		{
			$response = array();
			if (pjSurveyUserModel::factory()->setAttributes(array('id' => $_GET['id']))->erase()->getAffectedRows() == 1)
			{
				pjSurveyUserDetailModel::factory()->where('survey_user_id', $_GET['id'])->eraseAll();
				$response['code'] = 200;
			} else {
				$response['code'] = 100;
			}
			pjAppController::jsonResponse($response);
		}
		exit;
	}
	
	public function pjActionDeleteCompletedSurveyBulk()
	{
		$this->setAjax(true);
	
		if ($this->isXHR())
		{
			if (isset($_POST['record']) && count($_POST['record']) > 0)
			{
				pjSurveyUserModel::factory()->whereIn('id', $_POST['record'])->eraseAll();
				pjSurveyUserDetailModel::factory()->whereIn('survey_user_id', $_POST['record'])->eraseAll();
			}
		}
		exit;
	}
	
	public function pjActionGetExample()
	{
		$this->setAjax(true);
		
		if ($this->isXHR() && $this->isLoged())
		{
			$sid = $_GET['sid'];
			$theme = isset($_GET['theme']) ? $_GET['theme'] : 1;
			$search = array('{PJ_INSTALL_URL}', '{SID}', '{THEME}', '{A_TEXT}');
			$replace = array(PJ_INSTALL_URL, $sid, $theme, __('install_link', true));
				
			$content = @file_get_contents(PJ_VIEWS_PATH . 'pjAdminSurveys/elements/example-1.php');
			if ($content !== FALSE)
			{
				$this->set('example_1', str_replace($search, $replace, $content));
			}
			
			$content = @file_get_contents(PJ_VIEWS_PATH . 'pjAdminSurveys/elements/example-3.php');
			if ($content !== FALSE)
			{
				$this->set('example_3', str_replace($search, $replace, $content));
			}
		}
	}
	
	public function pjActionPrintSurvey()
	{
		$this->checkLogin();
		
		if ($this->isAdmin())
		{
			$this->setLayout('pjActionPrint');
			
			if (isset($_GET['uuid']) && !empty($_GET['uuid'])) {
				$arr = pjSurveyUserModel::factory()->select('t1.*, t2.name AS client_name, t2.company_name, t3.content AS survey_title')
					->join('pjUser', 't2.id=t1.user_id', 'left outer')
					->join('pjMultiLang', "t3.foreign_id = t1.survey_id AND t3.model = 'pjSurvey' AND t3.locale = '".$this->getLocaleId()."' AND t3.field = 'title'", 'left')
					->where('t1.uuid', $_GET['uuid'])
					->where('t1.status', 'completed')
					->limit(1)->findAll()->getData();
				if ($arr) {
					$arr = $arr[0];
					$pjSurveyModel  = pjSurveyModel::factory();
					$pjSurveyQuestionModel = pjSurveyQuestionModel::factory();
					$pjSurveyAnswerModel = pjSurveyAnswerModel::factory();
					$pjSurveyUserDetailModel = pjSurveyUserDetailModel::factory();
					
					$survey_arr = $pjSurveyModel->select('t1.*, t2.content AS `title`, t3.content AS `description`, t4.content AS `completion_confirmation`')
						->join('pjMultiLang', "t2.foreign_id = t1.id AND t2.model = 'pjSurvey' AND t2.locale = '".$arr['locale_id']."' AND t2.field = 'title'", 'left')
						->join('pjMultiLang', "t3.foreign_id = t1.id AND t3.model = 'pjSurvey' AND t3.locale = '".$arr['locale_id']."' AND t3.field = 'description'", 'left')
						->join('pjMultiLang', "t4.foreign_id = t1.id AND t4.model = 'pjSurvey' AND t4.locale = '".$arr['locale_id']."' AND t4.field = 'completion_confirmation'", 'left')
						->find($arr['survey_id'])->getData();
					$this->set('survey_arr', $survey_arr);
					
					$pjSurveyQuestionModel->reset()->select('t1.*, t2.content AS `question`, , t3.content AS `additional_information`, (SELECT COUNT(*) FROM `'.$pjSurveyAnswerModel->getTable().'` WHERE `question_id`=t1.id AND `show_checkbox`="T" AND t1.type="multi") AS cnt_open_answer_with_checkbox')
						->join('pjMultiLang', "t2.model='pjSurveyQuestion' AND t2.foreign_id=t1.id AND t2.field='question' AND t2.locale='".$arr['locale_id']."'", 'left outer')
						->join('pjMultiLang', "t3.model='pjSurveyQuestion' AND t3.foreign_id=t1.id AND t3.field='additional_information' AND t3.locale='".$arr['locale_id']."'", 'left outer')
						->where('t1.survey_id', $arr['survey_id'])
						->where('t1.status', 'T');
					$question_ids_arr = $pjSurveyQuestionModel->orderBy('t1.lft ASC')->findAll()->getDataPair(null, 'id');
					$question_arr = $pjSurveyQuestionModel->orderBy('t1.lft ASC')->findAll()->getData();
					
					$answer_arr = array();
					if ($question_ids_arr) {
						$_answer_arr = $pjSurveyAnswerModel
							->select('t1.*, t2.content AS `answer`')
							->whereIn('t1.question_id', $question_ids_arr)
							->join('pjMultiLang', "t2.model='pjSurveyAnswer' AND t2.foreign_id=t1.id AND t2.field='answer' AND t2.locale='".$arr['locale_id']."'", 'left outer')
							->findAll()
							->getData();
						foreach ($_answer_arr as $item) {
							$answer_arr[$item['question_id']][] = $item;
						}
					}
					
					$this->set('question_arr', $question_arr);
					$this->set('answer_arr', $answer_arr);
					
					$user_survey_detail_arr = array();
					$_user_survey_detail_arr = $pjSurveyUserDetailModel->where('t1.survey_user_id', (int)$arr['id'])->findAll()->getData();
					foreach ($_user_survey_detail_arr as $item) {
						if ((int)$item['answer_id'] > 0) {
							$user_survey_detail_arr[$item['question_id']]['answer_id'][] = $item['answer_id'];
							$user_survey_detail_arr[$item['question_id']]['open_answer'][$item['answer_id']] = $item['open_answer'];
						} else {
							$user_survey_detail_arr[$item['question_id']] = $item['open_answer'];
						}
					}
					$this->set('user_survey_detail_arr', $user_survey_detail_arr);
					$this->set('arr', $arr);
				}
			}
		} else {
			$this->set('status', 2);
		}
	}
}
?>