<?php
mt_srand();
$index = mt_rand(1, 9999);
$front_messages = __('front_messages', true, false);
$login_messages = __('login_messages', true, false);
$forgot_messages = __('forgot_messages', true, false);
$theme = isset($_GET['theme']) ? $_GET['theme'] : 1;

$time_to_complete = 'unlimited';
?>
<div id="pjWrapperSurvey_<?php echo $theme;?>">
	<div id="ssContainer_<?php echo $index; ?>" class="container-fluid pjSsContainer"></div>
</div>

<script type="text/javascript">
var pjQ = pjQ || {},
	StivaSurvey_<?php echo $index; ?>;
(function () {
	"use strict";
	
	var isSafari = /Safari/.test(navigator.userAgent) && /Apple Computer/.test(navigator.vendor),
		
	loadCssHack = function(url, callback){
		var link = document.createElement('link');
		link.type = 'text/css';
		link.rel = 'stylesheet';
		link.href = url;

		document.getElementsByTagName('head')[0].appendChild(link);

		var img = document.createElement('img');
		img.onerror = function(){
			if (callback && typeof callback === "function") {
				callback();
			}
		};
		img.src = url;
	},
	loadRemote = function(url, type, callback) {
		if (type === "css" && isSafari) {
			loadCssHack(url, callback);
			return;
		}
		var _element, _type, _attr, scr, s, element;
		
		switch (type) {
		case 'css':
			_element = "link";
			_type = "text/css";
			_attr = "href";
			break;
		case 'js':
			_element = "script";
			_type = "text/javascript";
			_attr = "src";
			break;
		}
		
		scr = document.getElementsByTagName(_element);
		s = scr[scr.length - 1];
		element = document.createElement(_element);
		element.type = _type;
		if (type == "css") {
			element.rel = "stylesheet";
		}
		if (element.readyState) {
			element.onreadystatechange = function () {
				if (element.readyState == "loaded" || element.readyState == "complete") {
					element.onreadystatechange = null;
					if (callback && typeof callback === "function") {
						callback();
					}
				}
			};
		} else {
			element.onload = function () {
				if (callback && typeof callback === "function") {
					callback();
				}
			};
		}
		element[_attr] = url;
		s.parentNode.insertBefore(element, s.nextSibling);
	},
	loadScript = function (url, callback) {
		loadRemote(url, "js", callback);
	},
	loadCss = function (url, callback) {
		loadRemote(url, "css", callback);
	},
	options = {
		server: "<?php echo PJ_INSTALL_URL; ?>",
		theme: "<?php echo $theme;?>",
		index: <?php echo $index; ?>,
		hide: <?php echo isset($_GET['hide']) && (int) $_GET['hide'] === 1 ? 1 : 0; ?>,
		locale: <?php echo isset($_GET['locale']) && (int) $_GET['locale'] > 0 ? (int) $_GET['locale'] : $controller->getLocaleId(); ?>,
		is_client_loggedin: "<?php echo $tpl['is_client_loggedin']; ?>",
		survey_started: "<?php echo isset($_SESSION[$controller->defaultClientSurveyData]['dt_start_survey']) && !empty($_SESSION[$controller->defaultClientSurveyData]['dt_start_survey']) ? 1 : 0;?>",
		view_user_survey_id: "<?php echo isset($_GET['view_user_survey_id']) ? (int)$_GET['view_user_survey_id'] : 0; ?>",			
		messages: {
			1: "<?php echo pjSanitize::clean($front_messages[1]); ?>",
			2: "<?php echo pjSanitize::clean($front_messages[2]); ?>",
			3: "<?php echo pjSanitize::clean($front_messages[3]); ?>",
			4: "<?php echo pjSanitize::clean($front_messages[4]); ?>",
			5: "<?php echo pjSanitize::clean($front_messages[5]); ?>",
			6: "<?php echo pjSanitize::clean($front_messages[6]); ?>",
			8: "<?php echo pjSanitize::clean($front_messages[8]); ?>",
			9: "<?php echo pjSanitize::clean($front_messages[9]); ?>"
		},
		login_messages: {
			100: "<?php echo pjSanitize::clean($login_messages[100]); ?>",
			101: "<?php echo pjSanitize::clean($login_messages[101]); ?>",
			102: "<?php echo pjSanitize::clean($login_messages[102]); ?>"
		},
		forgot_messages: {
			100: "<?php echo pjSanitize::clean($forgot_messages[100]); ?>",
			101: "<?php echo pjSanitize::clean($forgot_messages[101]); ?>",
			200: "<?php echo pjSanitize::clean($forgot_messages[200]); ?>"
		},
		email_exiting_message: "<?php echo pjSanitize::clean(__('front_email_existed', true));?>",
		update_profile_email_exiting_message: "<?php echo pjSanitize::clean(__('front_update_profile_email_existed', true));?>",
		validate_answer_msg: "<?php echo pjSanitize::clean(__('front_label_answer_required', true));?>",
		validate_open_answer_msg: "<?php echo pjSanitize::clean(__('front_label_open_answer_required', true));?>",
	};
	<?php
	$dm = new pjDependencyManager(PJ_INSTALL_PATH, PJ_THIRD_PARTY_PATH);
	$dm->load(PJ_CONFIG_PATH . 'dependencies.php')->resolve();
	?>
	loadScript("<?php echo PJ_INSTALL_URL . $dm->getPath('pj_jquery'); ?>pjQuery.min.js", function () {
		loadScript("<?php echo PJ_INSTALL_URL . $dm->getPath('pj_validate'); ?>pjQuery.validate.min.js", function () {
			loadScript("<?php echo PJ_INSTALL_URL . $dm->getPath('pj_bootstrap'); ?>pjQuery.bootstrap.min.js", function () {
				loadScript("<?php echo PJ_INSTALL_URL . PJ_JS_PATH; ?>pjSurvey.js", function () {
					StivaSurvey_<?php echo $index; ?> = new StivaSurvey(options);
				});
			});
		});
	});
})();
</script>